FloatTable data; 
float dataMin, dataMax; 

float coinGX, coinGY; 
float coinDX, coinDY; 

int yearMin, yearMax; 
int[] years; 
PFont font; 

int rowCount;
int columnCount; 
int currentColumn = 0; 

int yearInterval = 5;
int depenseInterval = 1000;
int actuel = 1;

void setup() { 
  size(720, 405); 
  font = createFont("Arial", 14);
  textFont (font);
  data = new FloatTable("tab_depense_eleve.tsv"); 
  years = int(data.getRowNames()); 
  yearMin = years[0]; 
  yearMax = years[years.length - 1]; 

  dataMin = 0; 
  dataMax = data.getTableMax(); 
  rowCount = data.getRowCount();

  // coin en haut à gauche  et en bas à droite
  coinGX = 30; 
  coinDX = width - coinGX; 
  coinGY = 40; 
  coinDY = height - coinGY; 
  smooth(); 
}


void draw() { 
  background(224); 
  
  // champs des données 
  fill(255); 
  rectMode(CORNERS); 
  noStroke(); 
  rect(coinGX, coinGY, coinDX, coinDY); 
  
  // dessine le titre des données actuels
 drawTitle();

  // dessine les données 
drawDataPoints(currentColumn); 
drawYearLabels();
drawDepenseLabels();
} 


// methodes pour dessiner les points
void drawDataPoints(int col) { 
  for (int row = 0; row < rowCount; row++) { 
      float value = data.getFloat(row, col); 
      float x = map(years[row], yearMin, yearMax, coinGX, coinDX); 
      float y = map(value, dataMin, dataMax, coinDY, coinGY); 
      strokeWeight(5); 
      stroke(#5679C1); 
      point(x, y); 
    } 
} 

//ecrit le nom de l'actuel colonne en haut à gauche
void drawTitle() {
  fill(0);
  textSize(20);
  textAlign(LEFT);
  String title = data.getColumnName(currentColumn);
  text(title, coinGX, coinGY - 10);
}
// ecrit les années en bas
void drawYearLabels() {
  fill(0);
  textSize(10);
  textAlign(CENTER, TOP);
  stroke(224);
  strokeWeight(1);
  
  for (int row = 0; row < rowCount; row++) {
    if (years[row] % yearInterval == 0) {
      float x = map(years[row], yearMin, yearMax, coinGX, coinDX);
      text(years[row], x, coinDY + 5);
    }
  }
}
      // ecrit les années à gauche
void drawDepenseLabels() {
  fill(0);
  textSize(10);
  textAlign(RIGHT, BOTTOM);
  stroke(224);
  for (float i = dataMin; i < dataMax; i+=depenseInterval) {
      float y = map(i, dataMin, dataMax,  coinDY, coinGY);
      text(ceil(i),  coinGY -10, y);
  }
}
